-- This Utility will Automatcily create an Galaxy for you max scenes
--"star01.jpg" put under "3dsmax2\Scripts\"
-- Created by Tetsuya Takee 
-- Copyright(C) 1998 Tetsuya Takee

utility Gxy "Galaxy System V.1.61"
(
	group "Big Bang"
	(
	button create_gxy "Create Universe" width:120
	spinner siz_gxy "Universe Size:" range:[0.1,10,1] scale:0.1 enabled:true
	button delete_gxy "Delete Universe" width:120
	colorpicker uni1_col "color:" color:[0,3,6]enabled:true across:2
	colorpicker uni2_col "" color:[1,0,22]enabled:true offset:[-16,0]
	)
	group "ShiningStar"
	(
	button create_shstar "Create" width:60 across:2
	button delete_shstar "Delete" width:60
	radiobuttons shstar_typ labels:#("Flare", "Glow")
	spinner bdr_shstar "Star Border:" range:[1,100,1] scale:0.1 enabled:true
	spinner num_shstar "Star Number:" range:[100,2000,300] scale:1 enabled:true
	spinner siz_shstar "Star Size:" range:[1,500,12] scale:0.1 enabled:true
	colorpicker shstar_col "Star color:" color:[180,140,255]enabled:true
	
	)
	group "SmallStar"
	(
	Slider sstar_val "SmallStar Value:" range:[0.65,0.75,0.7]enabled:true
	label dns_str "Dense <---------->Sparse" offset:[0,-6]
	)
	group "Nebula"
	(
	Slider neb_pha "Nebula Phase:" range:[-10,0,-5.2]enabled:true
	Slider neb2_pha "Nebula Phase2:" range:[-5,5,0]enabled:true
	Slider neb_val "Nebula Value:" range:[0.4,0.8,0.6]enabled:true
	label dns "Dense <---------->Sparse " offset:[0,-6]
	colorpicker neb_col "Nebula color:" color:[5,5,254]enabled:true
	)
	group "Dark Matter"
	(
	Slider drk_pha "Dark Matter Phase:" range:[-5,5,1]enabled:true
	Slider drk_val "Dark Matter Value:" range:[-0.2,0.2,0]enabled:true
	label drk "Dense <---------->Sparse" offset:[0,-6]
	)
	group "About"
	(
	label a1 "Beta .1.61 Galaxy System" 
	label b2 "By Tetsuya Takee" offset:[0,-6]
	button ab "About"
	)
	on ab pressed do
		
		(
		messagebox "Created by Tetsuya Takee 4/26/98, Thanks to Frank DeLise(Enviorment System)"
		messagebox "Checkout http://home.att.ne.jp/gold/takee/ or Email me takee@tka.att.ne.jp"
		)
	
	on create_gxy pressed do
		(
		backgroundColor = [0,0,0]
		
		addAtmospheric
		
		useEnvironmentMap = on
		
		mat2 = environmentMap
		
		function Rview =
		(
	
	--Noise Paramaters
	
		Mixam = noise phase:(drk_pha.value) Noise_Size:(siz_gxy.value*30) noiseType:1 Color_1:(Color 255 255 255) Color_2:(Color 0 0 0) map1Enabled:off map2Enabled:off Levels:4.5 Low_Threshold:(drk_val.value+0.38) High_Threshold:(drk_val.value+0.68)

		smstar = noise phase:0 Noise_Size:(siz_gxy.value*7) noiseType:1 Color_1:(Color 166 151 255) Color_2:(Color 254 255 237) map1Enabled:off map2Enabled:off Levels:6 Low_Threshold:0.4 High_Threshold:0.6

		nois10 = noise phase:-2.8 Noise_Size:(siz_gxy.value*1.1) noiseType:1 Color_1:(Color 255 223 45) Color_2:(Color 255 255 255) map1Enabled:off map2Enabled:off Levels:4 Low_Threshold:0.1 High_Threshold:0.9

		nois09 = noise phase:-6.3 Noise_Size:(siz_gxy.value*10) noiseType:0 Color_1:(Color 255 0 0) Color_2:(Color 255 87 13) map1Enabled:off map2Enabled:off Low_Threshold:0.2 High_Threshold:0.8

		nois08 = noise phase:-2.6 Noise_Size:(siz_gxy.value*30) noiseType:1 map1:nois09 map2:nois10 map1Enabled:on map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:2 Low_Threshold:0.42 High_Threshold:0.485

		nois07 = noise phase:2.8 Noise_Size:(siz_gxy.value*16) noiseType:0 Color_1:(neb_col.color) Color_2:(Color 0 120 250) map1Enabled:off map2Enabled:off Low_Threshold:0.42 High_Threshold:0.7

		nois06 = noise phase:0.2 Noise_Size:(siz_gxy.value*8.4) noiseType:1 map1:nois07 map2:nois08 map1Enabled:on map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:3.2 Low_Threshold:0.34 High_Threshold:0.76

		nois05 = noise phase:-0.2 Noise_Size:(siz_gxy.value*2.6) noiseType:1 Color_1:(neb_col.color) map2:nois06 map1Enabled:off map2Enabled:on Levels:4 Low_Threshold:0.28 High_Threshold:0.71

		nois04 = noise phase:(neb2_pha.value) Noise_Size:(siz_gxy.value*3) noiseType:2 map2:nois05 map1Enabled:off map2Enabled:on Color_1:(Color 11 0 36) Color_2:(Color 255 255 255) Levels:4 Low_Threshold:0.01 High_Threshold:0.3

		nois03 = noise phase:(neb_pha.value+0.4) Noise_Size:(siz_gxy.value*10) noiseType:1 Color_1:(uni1_col.color) Color_2:(uni2_col.color) Levels:3 map1Enabled:off map2Enabled:off Low_Threshold:0.3 High_Threshold:0.7

		nois02 = noise phase:(neb_pha.value) Noise_Size:(siz_gxy.value*15) noiseType:1 map1:nois03 map2:nois04 map1Enabled:on map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:5.5 Low_Threshold:(neb_val.value) High_Threshold:1.0

		nois01 = noise phase:0 Noise_Size:(siz_gxy.value*0.5) noiseType:1 map1:nois02 map2:smstar map1Enabled:on map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:3.0 Low_Threshold:(sstar_val.value) High_Threshold:1.0
				
		mat2 = mask mask:Mixam mask:Mixam map:nois01 mapEnabled:on maskEnabled:on
		
		environmentMap = mat2
		
		)
		Rview()
		)
	
	on delete_gxy pressed do
		(
		backgroundColor = [0,0,0]
		useEnvironmentMap = off
		)
	on uni1_col changed value do
		(
		
		Rview()
				
		)
		
	on uni2_col changed value do
		(
		
		Rview()
				
		)
		
	on create_shstar pressed do
		(
		mat3 = standardmaterial shininess:0 shinestrength:0 selfillum:0 opacity:0
		sppa = sphere radius:(bdr_shstar.value*1000) pos:[0,0,0]
		addmodifier sppa (normalmodifier flip:true)
		sppa.mat = mat3
		sppa.name = "ShinStarBase"
		
		--Create ShiningStar Bitmap
		
		tex = bitmaptexture()
		tex.coordinates.blur = 1
 		tex.coordinates.mapping = 2
		tex.coordinates.phase = 0.1
		tex.coordinates.Noise_Size = 0.1
		tex.coordinates.Noise_Amount = 0.1
		tex.coordinates.Noise_Levels = 1
		tex.filename = "3dsmax2\\Scripts\\star01.jpg"
		tex.mappingType = 1
		tex.filtertype = 2
		
		mat4 = standardmaterial()
		mat4.diffuse = [255,255,255]
		if shstar_typ.state == 1 then
		(
		--Create ShiningStar A
		mat4.diffusemap = gradient color1:(Color 1 1 1) color2:(shstar_col.color) color3:(Color 255 255 255) color2Pos:0.5 gradientType:2
		mat4.opacitymap = tex
		)else(
		--Create ShiningStar B
		mat4.diffusemap = gradient color1:(Color 1 1 1) color2:(shstar_col.color) color3:(Color 255 255 255) color2Pos:0.2 gradientType:2
		mat4.opacitymap = gradient color1:(Color 1 1 1) color2:(Color 50 50 50) color3:(Color 255 255 255) color2Pos:0.15 gradientType:2
		)
		mat4.diffusemapenable = on
		mat4.shininess = 0
		mat4.shinestrength = 0
		mat4.selfillum = 100
		mat4.opacitymapenable = on
		mat4.opacitymapamount = 100
		mat4.shading = 1
		mat4.facemap = true
		mat4.twosided = true
		mat4.name = "Starmap"
		
		--Create ShiningStar Particle
		pa = parray emitterHidden:off size:(siz_shstar.value) Size_Variation:80 seed:(random 1 99999) mappingType:1 formation:0 iconsize:10 viewType:1 viewPercent:100 emitterHidden:true quantityMethod:1 speed:0 life:1000 Display_Until:1000 Emitter_Start:-1 Emitter_Stop:0  emitter:sppa standardParticle:3 materialSource:0 Growth_Time:0 Fade_Time:0 Total_Number:(num_shstar.value) Percentage_Displayed:100 Spin_Time:0 Spin_Phase:0
		pa.mat = mat4
		pa.name = "ShinStar"
		
		hide $ShinStarBase
		)
		
	on shstar_typ changed state do
		(
		mat4 = standardmaterial()
		mat4.diffuse = [255,255,255]
		if shstar_typ.state == 1 then
		(
		--Create ShiningStar A
		mat4.diffusemap = gradient color1:(Color 1 1 1) color2:(shstar_col.color) color3:(Color 255 255 255) color2Pos:0.5 gradientType:2
		mat4.opacitymap = tex
		)else(
		--Create ShiningStar B
		mat4.diffusemap = gradient color1:(Color 1 1 1) color2:(shstar_col.color) color3:(Color 255 255 255) color2Pos:0.2 gradientType:2
		mat4.opacitymap = gradient color1:(Color 1 1 1) color2:(Color 50 50 50) color3:(Color 255 255 255) color2Pos:0.15 gradientType:2
		)
		mat4.diffusemapenable = on
		mat4.shininess = 0
		mat4.shinestrength = 0
		mat4.selfillum = 100
		mat4.opacitymapenable = on
		mat4.opacitymapamount = 100
		mat4.shading = 1
		mat4.facemap = true
		mat4.twosided = true
		mat4.name = "Starmap"
		pa.mat = mat4
		)
		
	on bdr_shstar changed value do
		(
		
		sppa.radius = bdr_shstar.value*1000
		
		select sppa
		
		)
		
	on num_shstar changed value do
		(
		
		pa.Total_Number = num_shstar.value
		
		select pa
		
		)
		
	on siz_shstar changed value do
		(
		
		pa.size = siz_shstar.value
		
		select pa
		
		)
		
	on shstar_col changed color do
		(
		mat4.diffusemap.color2 = shstar_col.color
		pa.mat = mat4
		
		)
		
	on delete_shstar pressed do
		(
		
		delete $ShinStar*
		
		)
	on siz_gxy changed value do
		(
		
		Rview()
		
		)
		
	on neb_val changed value do
		(
		
		Rview()
		
		)
		
	on neb_pha changed value do
		(
		
		Rview()
		
		)
		
	on neb2_pha changed value do
		(
		
		Rview()
		
		)
		
	on neb_col changed value do
		(
		
		Rview()
				
		)
		
	on sstar_val changed value do
		(
		
		Rview()
		
		)
		

	on drk_pha changed value do
		(
		
		Rview()
		
		)
		
	on drk_val changed value do
		(
		
		Rview()
		
		)
	
)
